
--[[
GreenLight, a simple mod by Carys of Terenas.
Version: 0.1
Documentation: See ReadMe.txt
--]]
GREENLIGHT_MESSAGE_PREFIX = "GLITE"
GREENLIGHT_ID = "GREENLIGHT"
GREENLIGHT_VERSION = "1.2.2"
GREENLIGHT_RED = "red"
GREENLIGHT_YELLOW = "yellow"
GREENLIGHT_GREEN = "green"
GREENLIGHT_UNKNOWN = "unknown"
GREENLIGHT_STARTUP_TIME = 0
GREENLIGHT_REASON = {
   ["MANUAL"] = "MANUAL",
   ["DEAD"] = "DEAD",
   ["AFK"] = "AFK",
   ["MANA"] = "MANA",
   ["HEALTH"] = "HEALTH",
   ["EATING"] = "EATING",
   ["DRINKING"] = "DRINKING",
   ["UNSET"] = "UNSET",
   ["GHOST"] = "GHOST",
   ["OFFLINE"] = "OFFLINE"
}

GREENLIGHT_CLASSES = {
   ["MAGE"] = "Ma",
   ["WARRIOR"] = "Wa",
   ["ROGUE"] = "Ro",
   ["SHAMAN"] = "Sh",
   ["PRIEST"] = "Pr",
   ["PALADIN"] = "Pa",
   ["WARLOCK"] = "Lo",
   ["DRUID"] = "Dr",
   ["HUNTER"] = "Hu",
   ["UNKNOWN"] = "Un"
}

GREENLIGHT_REASON_PRIORITIES = {
   [GREENLIGHT_REASON.UNSET] = 2,
   [GREENLIGHT_REASON.MANA] = 3,
   [GREENLIGHT_REASON.HEALTH] = 4,
   [GREENLIGHT_REASON.DRINKING] = 5,
   [GREENLIGHT_REASON.EATING] = 6,
   [GREENLIGHT_REASON.AFK] = 7,
   [GREENLIGHT_REASON.DEAD] = 8,
   [GREENLIGHT_REASON.GHOST] = 9,
   [GREENLIGHT_REASON.OFFLINE] = 10,
   [GREENLIGHT_REASON.MANUAL] = 11
}

GREENLIGHT_MY_STATE = {
   [GREENLIGHT_REASON.MANUAL] = GREENLIGHT_GREEN,
   [GREENLIGHT_REASON.DEAD] = GREENLIGHT_GREEN,
   [GREENLIGHT_REASON.GHOST] = GREENLIGHT_GREEN,
   [GREENLIGHT_REASON.AFK] = GREENLIGHT_GREEN,
   [GREENLIGHT_REASON.MANA] = GREENLIGHT_GREEN,
   [GREENLIGHT_REASON.HEALTH] = GREENLIGHT_GREEN,
   [GREENLIGHT_REASON.DRINKING] = GREENLIGHT_GREEN,
   [GREENLIGHT_REASON.EATING] = GREENLIGHT_GREEN,
   [GREENLIGHT_REASON.OFFLINE] = GREENLIGHT_GREEN
}

GREENLIGHT_LAST_OVERALL_STATE = GREENLIGHT_GREEN

GREENLIGHT_MODEL = YAK_SUBJECT:Create()
GREENLIGHT_MODEL.StateTable = {}
GREENLIGHT_MODEL.StatusTable = {}

GREENLIGHT_OBSERVER = YAK_OBSERVER:Create()
GREENLIGHT_BROADCASTER = YAK_OBSERVER:Create()
GREENLIGHT_BROADCASTER.LastBroadcastState = GREENLIGHT_GREEN

GL_REPORT_NAME_INDEX = 1
GL_REPORT_STATUS_INDEX = 2
GL_REPORT_REASON_INDEX = 3
GL_REPORT_VERSION_INDEX = 4

GL_REPORT_SORT_BY_NAME=1
GL_REPORT_SORT_BY_STATUS=2
GL_REPORT_SORT_BY_REASON=3

GREENLIGHT_CONFIG_DEFAULTS = {
   ["DEFAULT_CHANNEL"] = "GLPARTY",
   ["CHANNEL"] = "GLPARTY",
   ["AUTO_USE_CTRA_CHANNEL"] = true,
   ["SORT"] = GL_REPORT_SORT_BY_STATUS,
   ["AUTO_SET_MANA"] = true,
   ["MANA_YELLOW"] = 70,
   ["MANA_RED"] = 30,
   ["AUTO_SET_HEALTH"] = true,
   ["HEALTH_YELLOW"] = 70,
   ["HEALTH_RED"] = 30,
   ["GUESS_IF_NO_MOD"] = true,
   ["GUESS_TIMER_INTERVAL"] = 2, -- update every 2 second
   ["HIDE_WHEN_SOLO"] = false,
   ["BACKGROUND_ALPHA"] = 100,
   ["INDICATOR_SIZE"] = 32,
   ["DISABLE_GUESS_IN_COMBAT"] = true,
   ["LOG"] = false,
   ["LOCK_INDICATOR"] = false,
   ["AUTO_JOIN_CHANNEL"] = false,
   ["HIDE_IN_COMBAT"] = false
}

function GL_SetDefaults()
   GREENLIGHT_CONFIG = {}
   for k,v in GREENLIGHT_CONFIG_DEFAULTS do
      GREENLIGHT_CONFIG[k]=v
   end
end

function GL_Print( msg ) 
   local chatframe
   chatframe = DEFAULT_CHAT_FRAME
   chatframe:AddMessage( msg );
end

function GL_Log( msg ) 
   if GL_Logger then
      GL_Logger:Log(msg)
   end
end

GREENLIGHT_CHANNELNUM = nil

function GL_JoinChannel()
   if GREENLIGHT_CHANNELNUM then return end
   -- let's see if our channel is joined!
   -- if not, try again
   local _,name = GetChannelName(1)
   GL_Log("Attempting to join channel "..GREENLIGHT_CONFIG.CHANNEL)
   if name then
      GL_Log("Channel 1 is active; attempting to join")
      GL_SetChannel({GREENLIGHT_CONFIG.CHANNEL})
      GREENLIGHT_CHANNELNUM = GetChannelName(GREENLIGHT_CONFIG.CHANNEL)
      GL_Log("GREENLIGHT_CHANNELNUM == "..GREENLIGHT_CHANNELNUM)
      if (GREENLIGHT_CHANNELNUM == 0) then
	 GREENLIGHT_CHANNELNUM = nil
	 YakScheduler:In(10, "Joining GL Channel", function()
						      GL_JoinChannel()
						   end)
      end
   else
      -- add this again to the at queue
      YakScheduler:In(1, "Joining GL Channel", function() GL_JoinChannel() end)
   end
end

function GL_OnLoad()
   this:RegisterEvent("ADDON_LOADED")
   this:RegisterEvent("CHAT_MSG_CHANNEL")
   this:RegisterEvent("VARIABLES_LOADED")
   this:RegisterEvent("PARTY_MEMBERS_CHANGED")
   this:RegisterEvent("RAID_ROSTER_UPDATE")
   -- events which may affect player state
   this:RegisterEvent("UNIT_HEALTH")
   this:RegisterEvent("UNIT_MANA")
   this:RegisterEvent("UNIT_RAGE")
   this:RegisterEvent("UNIT_ENERGY")
   this:RegisterEvent("PLAYER_FLAGS_CHANGED")
   this:RegisterEvent("PLAYER_DEAD")
   this:RegisterEvent("PLAYER_UNGHOST")
   this:RegisterEvent("PLAYER_ALIVE")
   this:RegisterEvent("PLAYER_REGEN_DISABLED")
   this:RegisterEvent("PLAYER_REGEN_ENABLED")
   this:RegisterEvent("CHAT_MSG_SYSTEM")
   this:RegisterEvent("PLAYER_AURAS_CHANGED")
   -- slash commands
   SLASH_GREENLIGHT1 = "/greenlight"
   SLASH_GREENLIGHT2 = "/gl"
   GREENLIGHT_STARTUP_TIME = GetTime()
   SlashCmdList["GREENLIGHT"] = GL_ConsoleCommand
   GL_SetDefaults()
   GREENLIGHT_MODEL:RegisterObserver( GREENLIGHT_OBSERVER )
   GREENLIGHT_MODEL:RegisterObserver( GREENLIGHT_BROADCASTER )
   -- set up event so that we join channels after a bit
   YakScheduler:Every(GREENLIGHT_CONFIG.GUESS_TIMER_INTERVAL, "GL_Guessing", function() GL_OnUpdateGuess() end)
end


GREENLIGHT_ROSTER_CHANGED_BROADCAST_TIMER = nil

function GL_EnglishClass(unit)
   local localclass, englishclass = UnitClass(unit)
   return englishclass
end

function GL_OnUpdateGuess()
   if GREENLIGHT_CONFIG.GUESS_IF_NO_MOD then
--      GL_Log("OnUpdateGuess")
      if not (GREENLIGHT_CONFIG.DISABLE_GUESS_IN_COMBAT and UnitAffectingCombat("player")) then
	 GL_GuessUnknowns();
      end
   end
end

function GL_GuessedStatus( unit )
--   GL_Log("Guessing status for " .. UnitName(unit))
   --check offline
   if not UnitIsConnected(unit) then
      return GREENLIGHT_RED, GREENLIGHT_REASON.OFFLINE
   --check dead
   elseif UnitIsDead(unit) then
      return GREENLIGHT_RED, GREENLIGHT_REASON.DEAD
   -- check if ghost
   elseif UnitIsGhost(unit) then
      return GREENLIGHT_RED, GREENLIGHT_REASON.GHOST
   --check buffs (eating/drinking)
   --check health
   elseif GL_HealthStatus(unit, GREENLIGHT_CONFIG.HEALTH_YELLOW, GREENLIGHT_CONFIG.HEALTH_RED) ~= GREENLIGHT_GREEN then
      if GL_IsEating( unit ) then
        return GL_HealthStatus(unit, GREENLIGHT_CONFIG.HEALTH_YELLOW, GREENLIGHT_CONFIG.HEALTH_RED), GREENLIGHT_REASON.EATING
      else
        return GL_HealthStatus(unit, GREENLIGHT_CONFIG.HEALTH_YELLOW, GREENLIGHT_CONFIG.HEALTH_RED), GREENLIGHT_REASON.HEALTH
      end
   --check mana
   elseif GL_ManaStatus(unit, GREENLIGHT_CONFIG.MANA_YELLOW, GREENLIGHT_CONFIG.MANA_RED) ~= GREENLIGHT_GREEN then
      if GL_IsDrinking(unit) then
        return GL_ManaStatus(unit, GREENLIGHT_CONFIG.HEALTH_YELLOW, GREENLIGHT_CONFIG.HEALTH_RED, 25), GREENLIGHT_REASON.DRINKING
      else 
        return GL_ManaStatus(unit, GREENLIGHT_CONFIG.HEALTH_YELLOW, GREENLIGHT_CONFIG.HEALTH_RED, 25), GREENLIGHT_REASON.MANA
      end
   else
      return GREENLIGHT_GREEN, GREENLIGHT_REASON.MANUAL
   end
end

function GL_GuessStatusOfUnitId( unit )
   local name = UnitName( unit )
   if GREENLIGHT_MODEL:Version(name) == GREENLIGHT_VERSION_UNSET then
      local status, reason = GL_GuessedStatus(unit)
--      GL_Log("Guessed "..status..":"..reason)
      GREENLIGHT_MODEL:SetState(name, status, reason, GREENLIGHT_VERSION_UNSET, GL_EnglishClass(unit))
   else
      if not UnitIsConnected(unit) then
	 GREENLIGHT_MODEL:SetState(name, GREENLIGHT_RED, GREENLIGHT_REASON.OFFLINE, GREENLIGHT_MODEL:Version(name), GL_EnglishClass(unit))
      end
   end
end

function GL_GuessUnknowns()
   -- loop through our table; anyone with a version of GREENLIGHT_VERSION_UNSET
   -- we'll guess on
--   GL_Log("Guessing unknowns")
   if yak_PlayerIsSolo() then
      return
   elseif yak_PlayerIsInRaid() then
      for i,id in yak_eachRaidID() do
	 GL_GuessStatusOfUnitId( id )
      end
   elseif yak_PlayerIsInGroup() then
      for i, id in yak_eachPartyID() do
	 GL_GuessStatusOfUnitId( id )
      end
   end
--   GL_UpdateIndicatorStrings()
end

function GL_OnRosterUpdate()
--   if (yak_PlayerIsInRaid() and GREENLIGHT_AUTO_USE_CTRA_CHANNEL and CT_RA_Channel) then
--      GREENLIGHT_CONFIG.CHANNEL = CT_RA_Channel
--   else
--      GREENLIGHT_CONFIG.CHANNEL = GREENLIGHT_CONFIG.DEFAULT_CHANNEL
--   end
   GL_RefreshStateTable()
   --GL_BroadcastMyState( true )
   YakScheduler:In(2, "GLBroadcastState", function() GREENLIGHT_BROADCASTER:BroadcastMyState() end)
--   GREENLIGHT_ROSTER_CHANGED_BROADCAST_TIMER = GetTime() + 2
end

GREENLIGHT_EVENT_HANDLERS = {
   ["ADDON_LOADED"] = function() GL_Log("Addon Loaded") end,
   ["VARIABLES_LOADED"] = function() 
			     GL_Logger = YAK_LOGGER:Create( GREENLIGHT_CONFIG.LOG, {0.5,0.5,0.5} )

			     GL_Log("Variables Loaded");
			     -- if a new config variable has been added, it's not loaded and the value
			     -- will be nil; load the default in that case.
			     for k,v in GREENLIGHT_CONFIG_DEFAULTS do
				if GREENLIGHT_CONFIG[k] == nil then
				   GREENLIGHT_CONFIG[k] = v
				end
			     end
			     GL_RefreshStateTable()
			     GL_SetMyState(GREENLIGHT_REASON.MANUAL, GREENLIGHT_GREEN)
			     GL_ResizeIndicator(GREENLIGHT_CONFIG.INDICATOR_SIZE)
			     GL_SetIndicatorAlpha(GREENLIGHT_CONFIG.BACKGROUND_ALPHA / 100)
			     if GREENLIGHT_CONFIG.AUTO_JOIN_CHANNEL then
				GL_Log("Attempting to join channel in 2 seconds")
				YakScheduler:In(10, "Joining GL channel", function () GL_JoinChannel() end )
			     end
			  end,
   ["CHAT_MSG_CHANNEL"] = function() 
			     GL_ProcessChatMessage(arg2, arg9, arg1)
			  end,
   ["RAID_ROSTER_UPDATE"] = function() 
			       GL_Log("Event: " .. event); 
			       GL_OnRosterUpdate() 
			    end,
   ["PARTY_MEMBERS_CHANGED"] = function() 
			       GL_Log("Event: " .. event); 
			       GL_OnRosterUpdate() 
			    end,
   ["PLAYER_DEAD"] = function()
			GL_SetMyState(GREENLIGHT_REASON.DEAD, GREENLIGHT_RED)
		     end,
   ["PLAYER_ALIVE"] = function()
			 -- really check for death in this case, since PLAYER_ALIVE also fires when you
			 -- feign death, release and become a ghost, etc
			 if UnitIsDead("player") then
			    GL_SetMyState(GREENLIGHT_REASON.DEAD, GREENLIGHT_RED)
			 elseif UnitIsGhost("player") then
			    GL_SetMyState(GREENLIGHT_REASON.GHOST, GREENLIGHT_RED)
			 else
			    GL_SetMyState(GREENLIGHT_REASON.DEAD, GREENLIGHT_GREEN)
			    GL_SetMyState(GREENLIGHT_REASON.GHOST, GREENLIGHT_GREEN)
			 end
		      end,
   ["PLAYER_UNGHOST"] = function()
			   -- really check for death in this case, since PLAYER_ALIVE also fires when you
			   -- feign death, release and become a ghost, etc
			   if UnitIsDead("player") then
			      GL_SetMyState(GREENLIGHT_REASON.DEAD, GREENLIGHT_RED)
			   elseif UnitIsGhost("player") then
			      GL_SetMyState(GREENLIGHT_REASON.GHOST, GREENLIGHT_RED)
			   else
			      GL_SetMyState(GREENLIGHT_REASON.DEAD, GREENLIGHT_GREEN)
			      GL_SetMyState(GREENLIGHT_REASON.GHOST, GREENLIGHT_GREEN)
			   end
			end,
   ["PLAYER_FLAGS_CHANGED"] = function()
				 GL_Log("Flags Changed")
			      end,
   ["UNIT_HEALTH"] = function()
			if arg1 == "player" then
			   GL_OnHealthChanged()
			end
		     end,
   ["UNIT_MANA"] = function()
		      if arg1 == "player" then
			 GL_OnManaChanged()
		      end
		   end,
   ["UNIT_RAGE"] = function()
		      if arg1 == "player" then
			 GL_OnManaChanged()
		      end
		   end,
   ["UNIT_ENERGY"] = function()
		      if arg1 == "player" then
			 GL_OnManaChanged()
		      end
		   end,
   ["CHAT_MSG_SYSTEM"] = function()
			    local afkStr = string.gsub(MARKED_AFK_MESSAGE, "%%s", "(.-)")
			    if string.find(arg1, afkStr) then
			       --YakScheduler:In(0.1, "Setting AFK", function() GL_SetMyState(GREENLIGHT_REASON.AFK, GREENLIGHT_RED) end)
			       GL_SetMyState(GREENLIGHT_REASON.AFK, GREENLIGHT_RED)
			    elseif arg1 == CLEARED_AFK then
			       YakScheduler:In(0.1, "Clearing AFK", function() GL_SetMyState(GREENLIGHT_REASON.AFK, GREENLIGHT_GREEN) end)
--			    elseif string.find(arg1, string.sub(MARKED_DND,0,-5)) then
--			       GL_Print("GL: DND w/message")
--			    elseif arg1 == CLEARED_DND then
--			       GL_Print("GL: Not DND")
			    end
			 end,
   ["PLAYER_AURAS_CHANGED"] = function()
				 if not GL_IsEating("player") then
				    GL_SetMyState(GREENLIGHT_REASON.EATING, GREENLIGHT_GREEN)
				 end
				 if not GL_IsDrinking("player") then
				    GL_SetMyState(GREENLIGHT_REASON.DRINKING, GREENLIGHT_GREEN)
				 end
			      end,
   ["PLAYER_REGEN_DISABLED"] = function()
				  GL_Log("Regen disabled")
				  if GREENLIGHT_CONFIG.HIDE_IN_COMBAT then
				     GL_Log("Hiding Frame")
				     GreenLightFrame:Hide()
				  end
			       end,
   ["PLAYER_REGEN_ENABLED"] = function()
				 GL_Log("Regen enabled")
				 if not (GREENLIGHT_CONFIG.HIDE_WHEN_SOLO and yak_PlayerIsSolo()) then
				    GL_Log("Showing Frame")
				    GreenLightFrame:Show()
				 end
			      end
}

function GL_IsEating(unit)
   return yak_BuffsMatchPattern(unit,"&Knife$")
end

function GL_IsDrinking(unit)
   return yak_BuffsMatchPattern(unit,"\\INV_Drink")
end

function GL_WorstStatus(lhs,rhs)
   --returns whichever status is "worst" (unknown < red < yellow < green)
   if lhs == GREENLIGHT_RED or rhs == GREENLIGHT_RED then
      return GREENLIGHT_RED
   elseif lhs == GREENLIGHT_YELLOW or rhs == GREENLIGHT_YELLOW then
      return GREENLIGHT_YELLOW
   elseif lhs == GREENLIGHT_GREEN or rhs == GREENLIGHT_GREEN then
      return GREENLIGHT_GREEN
   else
      return GREENLIGHT_UNKNOWN
   end
end

function GL_IsWorseThan(lhs,rhs)
   -- returns true if the LHS argument is actually worse than the rhs argument,
   -- false if they are equal or LHS is better than RHS
   -- strangely, "unknown" is the "best" status--because we prefer having ANY status to that
   if lhs == GREENLIGHT_RED then
      if rhs == GREENLIGHT_RED then
	 return false
      else
	 return true
      end
   elseif lhs == GREENLIGHT_YELLOW then
      if rhs == GREENLIGHT_GREEN or rhs == GREENLIGHT_UNKNOWN then
	 return true
      else
	 return false
      end
   elseif lhs == GREENLIGHT_GREEN then
      if rhs == GREENLIGHT_UNKNOWN then
	 return true
      else
	 return false
      end
   end
end

function GL_PercentStatus(current, max, yellow_limit, red_limit)
   local pct = (current / max) * 100
   if pct > yellow_limit then
      return GREENLIGHT_GREEN
   elseif pct > red_limit then
      return GREENLIGHT_YELLOW
   else
      return GREENLIGHT_RED
   end
end

function GL_HealthStatus(unit, yellow_limit, red_limit)
   return GL_PercentStatus(UnitHealth(unit), UnitHealthMax(unit), yellow_limit, red_limit)
end

function GL_ManaStatus(unit, yellow_limit, red_limit)
   local playerclass, englishclass = UnitClass(unit)
   if englishclass == "WARRIOR" or englishclass == "ROGUE" then
      return GREENLIGHT_GREEN
   elseif englishclass == "DRUID" and (yak_BuffsMatchPattern(unit, "CatForm") or yak_BuffsMatchPattern(unit, "BearForm")) then
      GL_Log("CatForm")
      return GREENLIGHT_GREEN
   else
      return GL_PercentStatus(UnitMana(unit), UnitManaMax(unit), yellow_limit, red_limit)
   end
end

function GL_OnHealthChanged()
   GL_Log("Health Changed")
   
   if GREENLIGHT_CONFIG.AUTO_SET_HEALTH then
      local state = GL_HealthStatus("player", GREENLIGHT_CONFIG.HEALTH_YELLOW, GREENLIGHT_CONFIG.HEALTH_RED)
      GL_Log("Player health status now ".. state)
      if GL_IsEating("player") then
        GL_SetMyState(GREENLIGHT_REASON.EATING, state)
      end
      GL_SetMyState(GREENLIGHT_REASON.HEALTH, state )
   else
      GREENLIGHT_MY_STATE.HEALTH = GREENLIGHT_GREEN
   end
end

function GL_OnManaChanged()
   GL_Log("Mana/Rage/Energy changed")
   -- warriors just don't watch mana; it's reverse, y'see
   if GREENLIGHT_CONFIG.AUTO_SET_MANA then
      local state = GL_ManaStatus("player", GREENLIGHT_CONFIG.MANA_YELLOW, GREENLIGHT_CONFIG.MANA_RED)
      GL_Log("Player mana status now "..state)
      if GL_IsDrinking("player") then
        GL_SetMyState(GREENLIGHT_REASON.DRINKING, state)
      end
      GL_SetMyState(GREENLIGHT_REASON.MANA, state)
   else
      GREENLIGHT_MY_STATE.MANA = GREENLIGHT_GREEN
   end
end

function GL_OnEvent(event)
   -- process our incoming events
   func = GREENLIGHT_EVENT_HANDLERS[event]
   if func then
      func()
   end
end

function GL_IsValidName( name )
   if name == UnitName("player") then
      return true
   end
   if yak_PlayerIsInGroup() then
      for k,unitName in yak_eachPartyName() do
	 if name == unitName then
	    return true
	 end
      end
      return false
   elseif yak_PlayerIsInRaid() then
      for k, unitId in yak_eachRaidID() do
	 if UnitName(unitId) == name then
	    return true
	 end
      end
      return false
   end
   return false
end
   
function GL_ChannelToUse()
   local channel = GREENLIGHT_CONFIG.CHANNEL
   if yak_PlayerIsInRaid() and GREENLIGHT_CONFIG.AUTO_USE_CTRA_CHANNEL then
      channel = CT_RA_Channel
   end
   return channel
end

function GL_ProcessChatMessage(name, channel, fullmsg)
   if channel == GL_ChannelToUse() then
      local prefix, msg, reason, version = string.find(fullmsg, "([^%s]+) ([^%s]+) ([^%s]+) ([^%s]+)") --bits = yak_string_split(fullmsg)
      if prefix ~= GREENLIGHT_MESSAGE_PREFIX then -- bits[1]
	 GL_Log("Not GreenLight message; discarding")
      elseif (GL_IsValidName( name )) and name ~= UnitName("player") then
--	 local msg = bits[2]
--	 local reason = bits[3]
--	 local version = bits[4]
--	 TargetByName( name )
	 local class = "UNKNOWN"
	 if yak_PlayerIsInRaid() then
	    class = GL_EnglishClass(yak_IdOfUnitInRaid( name ))
	 elseif yak_PlayerIsInParty() then
	    class = GL_EnglishClass(yak_IdOfUnitInParty( name ))
	 end
	 -- hopefully class is not nil by now!
--	 TargetLastTarget()
	 --don't transmit class--we can get it from guessing
	 if ((msg=="red") or (msg=="yellow") or (msg=="green")) then
	    GL_Log("Changing " .. name .. " to " .. msg .. "because: "..reason)
	    GREENLIGHT_MODEL:SetState(name, msg, reason, version, class)
	    GL_RecalcOverallState()
	 elseif msg == "request" then
	    GL_Log("Request received; broadcasting my state")
	    GREENLIGHT_BROADCASTER:BroadcastMyState()
	 end
      end
   end
end

function GL_ToggleLog()
   GREENLIGHT_CONFIG.LOG = (GREENLIGHT_CONFIG.LOG == false)
   GL_Logger:SetLog( GREENLIGHT_CONFIG.LOG )
end
function GL_HasJoinedChannel( name ) 
   for i=1, 10 do
      local channelNumber, channelName = GetChannelName(i);
      if channelName then
	 if channelName == name then
	    return true
	 end
      end
   end
end

function GL_SetChannel( args )
   if getn(args) < 1 then
      GL_Print("GreenLight currently reports on channel "..GREENLIGHT_CONFIG.CHANNEL)
   else
      local channel = args[1]
      GL_Print("GreenLight: Setting channel to "..channel)

      GREENLIGHT_CONFIG.CHANNEL = channel
      GREENLIGHT_CONFIG.DEFAULT_CHANNEL = channel
      if GREENLIGHT_CONFIG.AUTO_JOIN_CHANNEL then
	 GL_Print("Joining channel "..GREENLIGHT_CONFIG.CHANNEL)
	 JoinChannelByName(GREENLIGHT_CONFIG.CHANNEL, nil, nil )
      else
	 GL_Print("Not automatically joining channel "..GREENLIGHT_CONFIG.CHANNEL.." as auto-join is not set.")
	 GL_Print("Note that manually joining this channel with /join may display GreenLight messages to your screen!")
	 GL_Print("To fix this, leave the channel, set auto-join, and then reset the channel with '/gl channel' or the config screen")
      end
   end
end


GL_SUBCOMMANDS = {
   ["statetable"] = function () GL_PrintStateTable(GREENLIGHT_MODEL.StateTable) end,
   ["status"] = function() GL_PrintStatus() end,
   ["report"] = function() GL_Report() end,
   ["log"] =  function() GL_ToggleLog() end,
   ["refresh"] = function() GL_RefreshStateTable() end,
   ["red"] = function() GL_SetMyState(GREENLIGHT_REASON.MANUAL, GREENLIGHT_RED) end,
   ["yellow"] = function() GL_SetMyState(GREENLIGHT_REASON.MANUAL, GREENLIGHT_YELLOW) end,
   ["green"] = function() GL_SetMyState(GREENLIGHT_REASON.MANUAL, GREENLIGHT_GREEN) end,
   ["show"] = function() GreenLightFrame:Show() end,
   ["hide"] = function() GreenLightFrame:Hide() end,
   ["config"] = function() GreenLightConfigFrame:Show() end,
   ["channel"] = function(args) GL_SetChannel(args) end, 
   ["sync"] = function() GL_BroadcastSyncRequest() end
}

function GL_BroadcastSyncRequest()
   SendChatMessage(GREENLIGHT_MESSAGE_PREFIX .. " request", "CHANNEL", "Common", GetChannelName(GL_ChannelToUse()) )
   GREENLIGHT_BROADCASTER:BroadcastMyState()
end

function GL_ConsoleCommand( message )
   -- parse and act on our console commands
   local commandlist = { }
   local command
   GL_Log("Command: " .. message)
   command, args = yak_console_command_string(message)
   if command then
      GL_Log("SubCommand: " .. command)
   end
   comfunc = GL_SUBCOMMANDS[command]
   if comfunc ~= nil then
      comfunc(args)
   else
      GL_Print("/greenlight, /gl   -- gives this usage statement")
      GL_Print("/gl red|green|blue -- sets your state")
      GL_Print("/gl refresh        -- refreshes your state table")
      GL_Print("/gl log            -- toggle display of debug messages")
      GL_Print("/gl report         -- shows current status report")
      GL_Print("/gl show | hide    -- shows/hides light frame")
      GL_Print("/gl config         -- configures GreenLight")
      GL_Print("/gl channel (name) -- sets and joins GreenLight channel")
      GL_Print("/gl sync           -- requests a sync with other clients in channel")
   end
end

function GL_SetMyState( type, color, reason )
   GREENLIGHT_MY_STATE[type] = color
   -- now calculate my new state
   local mystate
   local myreason
   mystate, myreason = GL_MyStateAndReason()
   GREENLIGHT_MODEL:SetMyStateAndReason( mystate, myreason )
end

function GL_GroupSize()
   -- Gets the size of the operating group the player is
   -- a part of.  Includes the player, so if 
   -- GL_GroupSize() returns 1, the player is solo
   if yak_PlayerIsInRaid() then
      return GetNumRaidMembers()
   elseif GL_IsInParty() then
      return GetNumPartyMembers() + 1
   else
      return 1
   end
end

function GL_BlankEntriesFromSolo()
   local result = {}
   result[UnitName("player")] = {GREENLIGHT_UNKNOWN,GREENLIGHT_REASON.UNSET,GREENLIGHT_VERSION_UNSET, "UNKNOWN"}
   return result
end

function GL_BlankEntriesFromGroup()
   local result = {}
   local unitId
   local index
   for k, unitName in yak_eachPartyName() do
      GL_Log("Adding ".. unitName)
      result[unitName] = {GREENLIGHT_UNKNOWN,GREENLIGHT_REASON.UNSET,GREENLIGHT_VERSION_UNSET, "UNKNOWN"}
   end
   result[UnitName("player")] = {GREENLIGHT_UNKNOWN,GREENLIGHT_REASON.UNSET,GREENLIGHT_VERSION_UNSET, "UNKNOWN"}
   --GL_PrintStateTable(result)
   return result
end

function GL_BlankEntriesFromRaid()
   local result = {}
   local name
   local index
   for k, unitId in yak_eachRaidID() do
      GL_Log("Adding "..UnitName(unitId))
      result[UnitName(unitId)] = {GREENLIGHT_UNKNOWN,GREENLIGHT_REASON.UNSET, GREENLIGHT_VERSION_UNSET, "UNKNOWN"}
   end
   result[UnitName("player")] = {GREENLIGHT_UNKNOWN, GREENLIGHT_REASON.UNSET, GREENLIGHT_VERSION_UNSET, "UNKNOWN"}
   return result
end
   
function GL_MyStateAndReason()
   -- calculates state and reason
   -- if our manual state is worse than the auto state, we use manual
   -- otherwise (ie manual == auto or auto is worse) we use auto
   local result = GREENLIGHT_GREEN
   local worstreason = GREENLIGHT_REASON.UNSET
   --first pass -- calculate worst state
   for k,v in GREENLIGHT_MY_STATE do
      if GL_IsWorseThan(v,result) then
	 result = v
      end
   end
   -- now a pass to figure out reason
   for k,v in GREENLIGHT_MY_STATE do
      if (v==result) then
	 if GREENLIGHT_REASON_PRIORITIES[k] > GREENLIGHT_REASON_PRIORITIES[worstreason] then
--	    GL_Log("Replacing reason " .. worstreason .. " with " .. k)
	    worstreason = k
	 end
      end
   end
   -- if we're green, things get stranger; we should be "manual" by this point, but I still want
   -- to show eating/drinking
   if worstreason == GREENLIGHT_REASON.MANUAL then
      if GL_IsEating("player") then
	 worstreason = GREENLIGHT_REASON.EATING
      elseif GL_IsDrinking("player") then
	 worstreason = GREENLIGHT_REASON.DRINKING
      end
   end
   return result, GREENLIGHT_REASON[worstreason]
end

function GL_RefreshStateTable()
   GREENLIGHT_MODEL:RefreshStateTable()
end


function GL_PrintMyStateTable()
   for k,v in GREENLIGHT_MY_STATE do
      GL_Print(k..":"..v)
   end
end

function GL_PrintStateTable(t)
   GL_Log("Printing state table")
   for key,item in t do
      GL_Print("Name: " .. key .. "; State: " .. item[1] .. "Reason: " .. item[2])
      if item[3] then GL_Print( "Version: " .. item[3] ) end
   end
end

function GL_BoolString(f)
   if (f) then
      return "True"
   else
      return "False"
   end
end

GL_WORD_TABLE = { 
   [GREENLIGHT_RED]="Red",
   [GREENLIGHT_GREEN] = "Green",
   [GREENLIGHT_YELLOW] = "Yellow",
   [GREENLIGHT_UNKNOWN] = "Unknown"
}
   

function GL_StatusWord(arg)
   return GL_WORD_TABLE[arg]
end

function GL_PrintStatus()
   local s = GREENLIGHT_MODEL:Status()
   GL_Print("Overall status: " .. GL_StatusWord(GREENLIGHT_MODEL:WorstStatus()) )
   GL_Print("G:"..s[GREENLIGHT_GREEN].."/Y:"..s[GREENLIGHT_YELLOW].."/R:"..s[GREENLIGHT_RED].."/?:"..s[GREENLIGHT_UNKNOWN])
end

function GL_BrightOrDark( state, color )
   if (color == state) then
      GL_Log("bright"..color)
      return "bright"
   else
      GL_Log("dark"..color)
      return "dark"
   end
end

function GL_RecalcOverallState()
end

function GL_UpdateIndicatorStrings()
   local status = GREENLIGHT_MODEL:Status()
   GreenLightFrameUnknownIndicatorString:SetText(status[GREENLIGHT_UNKNOWN])
   GreenLightFrameButton_redIndicatorString:SetText(status[GREENLIGHT_RED])
   GreenLightFrameButton_yellowIndicatorString:SetText(status[GREENLIGHT_YELLOW])
   GreenLightFrameButton_greenIndicatorString:SetText(status[GREENLIGHT_GREEN])
end


function GL_Frame_OnLoad()
   this:RegisterForDrag("LeftButton")
end

function GL_Frame_OnDragStart()
   if not GREENLIGHT_CONFIG.LOCK_INDICATOR then
      GreenLightFrame:StartMoving()
   end
end

function GL_Frame_OnDragStop()
   if not GREENLIGHT_CONFIG.LOCK_INDICATOR then
      GreenLightFrame:StopMovingOrSizing()
   end
end

function GL_PopulateReportTable()
   GREENLIGHT_REPORT_TABLE={}
   for k,v in GREENLIGHT_MODEL.StateTable do
      GL_Log("Adding " .. k .. ":" .. v[1] .. ":" .. v[2]..":")
      if v[3] == GREENLIGHT_VERSION_UNSET then
	 table.insert(GREENLIGHT_REPORT_TABLE, {GREENLIGHT_CLASSES[v[4]].." " ..k,v[1], GREENLIGHT_REASON_STRING[v[2]].."?", v[3]})
      else
	 table.insert(GREENLIGHT_REPORT_TABLE, {GREENLIGHT_CLASSES[v[4]].." ".. k,v[1],GREENLIGHT_REASON_STRING[v[2]],v[3]})
      end
   end
end

function GL_RefreshReport()
   GL_PopulateReportTable()
   GL_ScrollReportUpdate()
end

function GL_Report()
   GL_PopulateReportTable()
   GL_ScrollReportUpdate()
   GreenLightReportFrame:Show()
end

GREENLIGHT_COLOR_TABLE = {
   [GREENLIGHT_RED] = {1,0,0},
   [GREENLIGHT_YELLOW] = {1,1,0},
   [GREENLIGHT_GREEN] = {0,1,0},
   [GREENLIGHT_UNKNOWN] = {1,1,1}
}

function GL_ScrollReportUpdate()
   local numEntries = getn(GREENLIGHT_REPORT_TABLE);
   FauxScrollFrame_Update(GreenLightReportFrameScrollFrame, numEntries, 19, 20);

   for i = 1, 19, 1 do
      local button = getglobal("GreenLightReportFramePlayer" .. i);
      local index = i + FauxScrollFrame_GetOffset(GreenLightReportFrameScrollFrame);
      if ( index <= numEntries ) then
	 button:Show();
	 local color = GREENLIGHT_COLOR_TABLE[GREENLIGHT_REPORT_TABLE[index][GL_REPORT_STATUS_INDEX]]
	 if ( color ) then
	    getglobal(button:GetName() .. "Status"):SetTextColor(color[1], color[2], color[3]);
	    getglobal(button:GetName() .. "Reason"):SetTextColor(color[1], color[2], color[3]);
	 end
	 getglobal(button:GetName() .. "Name"):SetText(GREENLIGHT_REPORT_TABLE[index][GL_REPORT_NAME_INDEX])
	 getglobal(button:GetName() .. "Status"):SetText(GREENLIGHT_REPORT_TABLE[index][GL_REPORT_STATUS_INDEX])
	 getglobal(button:GetName() .. "Reason"):SetText(GREENLIGHT_REPORT_TABLE[index][GL_REPORT_REASON_INDEX])
	 getglobal(button:GetName() .. "Version"):SetText(GREENLIGHT_REPORT_TABLE[index][GL_REPORT_VERSION_INDEX])
      else
	 button:Hide();
      end
   end

end

GREENLIGHT_LT = 1
GREENLIGHT_EQ = 2
GREENLIGHT_GT = 3

GREENLIGHT_STATUS_LESS_THAN_TABLE = {
   [GREENLIGHT_UNKNOWN] = { 
      [GREENLIGHT_UNKNOWN] = GREENLIGHT_EQ,
      [GREENLIGHT_RED] = GREENLIGHT_GT,
      [GREENLIGHT_YELLOW] = GREENLIGHT_GT,
      [GREENLIGHT_GREEN] = GREENLIGHT_GT
   },
   [GREENLIGHT_RED] = {
      [GREENLIGHT_UNKNOWN] = GREENLIGHT_LT,
      [GREENLIGHT_RED] = GREENLIGHT_EQ,
      [GREENLIGHT_YELLOW] = GREENLIGHT_LT,
      [GREENLIGHT_GREEN] = GREENLIGHT_LT
   },
   [GREENLIGHT_YELLOW] = {
      [GREENLIGHT_UNKNOWN] = GREENLIGHT_LT,
      [GREENLIGHT_RED] = GREENLIGHT_GT,
      [GREENLIGHT_YELLOW] = GREENLIGHT_EQ,
      [GREENLIGHT_GREEN] = GREENLIGHT_LT
   },
   [GREENLIGHT_GREEN] = {
      [GREENLIGHT_UNKNOWN] = GREENLIGHT_LT,
      [GREENLIGHT_RED] = GREENLIGHT_GT,
      [GREENLIGHT_YELLOW] = GREENLIGHT_GT,
      [GREENLIGHT_GREEN] = GREENLIGHT_EQ
   }
}
      

GREENLIGHT_SORT_FUNCTIONS = {
   function (a,b) 
      return a[GL_REPORT_NAME_INDEX] < b[GL_REPORT_NAME_INDEX] 
   end,
   function (a,b) 
      local result = GREENLIGHT_STATUS_LESS_THAN_TABLE[a[GL_REPORT_STATUS_INDEX]][b[GL_REPORT_STATUS_INDEX]]
      if result == GREENLIGHT_EQ then
	 result = a[GL_REPORT_NAME_INDEX] < b[GL_REPORT_NAME_INDEX]
      else
	 if result == GREENLIGHT_LT then
	    result = true
	 else
	    result = false
	 end
      end
      return result
   end,
--      local av
--      local bv
--      bv = b[GL_REPORT_STATUS_INDEX]
--      av  = a[GL_REPORT_STATUS_INDEX]
--      if av == GREENLIGHT_RED then
--	 if b ~= GREENLIGHT_RED then
--	    return true
--	 end
--      elseif av == GREENLIGHT_YELLOW then
--	 if bv == GREENLIGHT_RED then
--	    return false
--	 elseif bv == GREENLIGHT_GREEN then
--	    return true
--	 end
--      else -- av == green
--	 if bv ~= GREENLIGHT_GREEN  then
--	    return false
--	 end
--      end
--   end,
   function (a,b) 
      local result =  a[GL_REPORT_REASON_INDEX] < b[GL_REPORT_REASON_INDEX]
      if result == false then
	 if a[GL_REPORT_REASON_INDEX] == b[GL_REPORT_REASON_INDEX] then
	    result = a[GL_REPORT_NAME_INDEX] < b[GL_REPORT_NAME_INDEX]
	 end
      end
      return result
   end
}

function GL_SortReportByColumn(col)
   table.sort( GREENLIGHT_REPORT_TABLE, GREENLIGHT_SORT_FUNCTIONS[col] )
   GL_ScrollReportUpdate()
end

function GL_SortReportByName()
   GL_Print("Sorting by Name")
   GL_SortReportByColumn(GL_REPORT_NAME_INDEX)
end

function GL_SortReportByStatus()
   GL_Print("Sorting by Status")
   GL_SortReportByColumn(GL_REPORT_STATUS_INDEX)
end

function GL_SortReportByReason()
   GL_Print("Sorting by Reason")
   GL_SortReportByColumn(GL_REPORT_REASON_INDEX)
end

function GL_OnDragManaYellow()
   GREENLIGHT_CONFIG.MANA_YELLOW = this:GetValue();
   if (GREENLIGHT_CONFIG.MANA_YELLOW < GREENLIGHT_CONFIG.MANA_RED) then
      GreenLightConfigFrameManaRedSlider:SetValue(GREENLIGHT_CONFIG.MANA_YELLOW)
   end
   getglobal(this:GetName().."Text"):SetText(GREENLIGHT_CONFIG_MANA_YELLOW_SLIDER .. ":"..this:GetValue().."%");
end

function GL_OnDragManaRed()
   GREENLIGHT_CONFIG.MANA_RED = this:GetValue();
   if ( GREENLIGHT_CONFIG.MANA_YELLOW < GREENLIGHT_CONFIG.MANA_RED) then
      GreenLightConfigFrameManaYellowSlider:SetValue(GREENLIGHT_CONFIG.MANA_RED)
   end
   getglobal(this:GetName().."Text"):SetText(GREENLIGHT_CONFIG_MANA_RED_SLIDER .. ":"..this:GetValue().."%");
end

function GL_OnDragHealthYellow()
   GREENLIGHT_CONFIG.HEALTH_YELLOW = this:GetValue();
   if (GREENLIGHT_CONFIG.HEALTH_YELLOW < GREENLIGHT_CONFIG.HEALTH_RED) then
      GreenLightConfigFrameHealthRedSlider:SetValue(GREENLIGHT_CONFIG.HEALTH_YELLOW)
   end
   getglobal(this:GetName().."Text"):SetText(GREENLIGHT_CONFIG_HEALTH_YELLOW_SLIDER .. ":"..this:GetValue().."%");
end

function GL_OnDragHealthRed()
   GREENLIGHT_CONFIG.HEALTH_RED = this:GetValue();
   if ( GREENLIGHT_CONFIG.HEALTH_YELLOW < GREENLIGHT_CONFIG.HEALTH_RED) then
      GreenLightConfigFrameHealthYellowSlider:SetValue(GREENLIGHT_CONFIG.HEALTH_RED)
   end
   getglobal(this:GetName().."Text"):SetText(GREENLIGHT_CONFIG_HEALTH_RED_SLIDER .. ":"..this:GetValue().."%");
end

function GL_OnDragGuessTimerInterval()
   GREENLIGHT_CONFIG.GUESS_TIMER_INTERVAL = this:GetValue();
   YakScheduler:SetCronDelay("GL_Guessing", GREENLIGHT_CONFIG.GUESS_TIMER_INTERVAL)
   getglobal(this:GetName().."Text"):SetText(GREENLIGHT_CONFIG_GUESS_DELAY_SLIDER .. ":"..this:GetValue().." sec");
end

function GL_SetRed()
   GL_Log("Setting state RED")
   GL_SetMyState(GREENLIGHT_REASON.MANUAL, GREENLIGHT_RED)
end

function GL_SetYellow()
   GL_Log("Setting state YELLOW")
   GL_SetMyState(GREENLIGHT_REASON.MANUAL, GREENLIGHT_YELLOW)
end

function GL_SetGreen()
   GL_Log("Setting state GREEN")
   GL_SetMyState(GREENLIGHT_REASON.MANUAL, GREENLIGHT_GREEN)
end

function GL_ShowTooltip( color )
   GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT"); 
   GameTooltip:ClearLines()
   -- get a list of the folks who are this color
   local charlist = {}
   for k,v in GREENLIGHT_MODEL.StateTable do
      if v[1] == color then
	 if v[3]==GREENLIGHT_VERSION_UNSET then
	    table.insert(charlist, {k, GREENLIGHT_REASON_STRING[v[2]].."?",v[4]})
	 else
	    table.insert(charlist,{k,GREENLIGHT_REASON_STRING[v[2]],v[4]})
	 end
      end
   end
   for k,v in ipairs( charlist ) do
      local colorvals = GREENLIGHT_COLOR_TABLE[color]
      GameTooltip:AddDoubleLine(GREENLIGHT_CLASSES[v[3]].." "..v[1], v[2], 1,1,1, colorvals[1], colorvals[2], colorvals[3])
   end
   GameTooltip:Show()
end

function GL_HideTooltip()
   GameTooltip:Hide()
end

function GL_OnDragAlpha()
   GREENLIGHT_CONFIG.BACKGROUND_ALPHA = this:GetValue()
   getglobal(this:GetName().."Text"):SetText(GREENLIGHT_CONFIG_FRAME_BACKGROUND_ALPHA_SLIDER .. ":"..this:GetValue().."%");
   GL_SetIndicatorAlpha(GREENLIGHT_CONFIG.BACKGROUND_ALPHA / 100)
end

function GL_SetConfigFrameFromConfig()
   GreenLightConfigFrameCheckButtonUseCTRAChannel:SetChecked(GREENLIGHT_CONFIG.AUTO_USE_CTRA_CHANNEL)
   GreenLightConfigFrameCheckButtonAutoSetMana:SetChecked(GREENLIGHT_CONFIG.AUTO_SET_MANA)
   GreenLightConfigFrameCheckButtonAutoSetHealth:SetChecked(GREENLIGHT_CONFIG.AUTO_SET_HEALTH)
   GreenLightConfigFrameManaYellowSlider:SetValue(GREENLIGHT_CONFIG.MANA_YELLOW)
   GreenLightConfigFrameManaRedSlider:SetValue(GREENLIGHT_CONFIG.MANA_RED)
   GreenLightConfigFrameHealthYellowSlider:SetValue(GREENLIGHT_CONFIG.HEALTH_YELLOW)
   GreenLightConfigFrameHealthRedSlider:SetValue(GREENLIGHT_CONFIG.HEALTH_RED)
   GreenLightConfigFrameCheckButtonGuess:SetChecked(GREENLIGHT_CONFIG.GUESS_IF_NO_MOD)
   GreenLightConfigFrameGuessIntervalSlider:SetValue(GREENLIGHT_CONFIG.GUESS_TIMER_INTERVAL)
   GreenLightConfigFrameCheckButtonHideWhenSolo:SetChecked(GREENLIGHT_CONFIG.HIDE_WHEN_SOLO)
   GreenLightConfigFrameBackgroundAlphaSlider:SetValue(GREENLIGHT_CONFIG.BACKGROUND_ALPHA)
   GreenLightConfigFrameIndicatorSizeSlider:SetValue(GREENLIGHT_CONFIG.INDICATOR_SIZE)
   if GREENLIGHT_CONFIG.AUTO_SET_MANA then
      GreenLightConfigFrameManaYellowSlider:Show()
      GreenLightConfigFrameManaRedSlider:Show()
   else
      GreenLightConfigFrameManaYellowSlider:Hide()
      GreenLightConfigFrameManaRedSlider:Hide()
   end

   if GREENLIGHT_CONFIG.AUTO_SET_HEALTH then
      GreenLightConfigFrameHealthYellowSlider:Show()
      GreenLightConfigFrameHealthRedSlider:Show()
   else
      GreenLightConfigFrameHealthYellowSlider:Hide()
      GreenLightConfigFrameHealthRedSlider:Hide()
   end

   if GREENLIGHT_CONFIG.GUESS_IF_NO_MOD then
      GreenLightConfigFrameGuessIntervalSlider:Show()
   else
      GreenLightConfigFrameGuessIntervalSlider:Hide()
   end

   if GREENLIGHT_CONFIG.HIDE_WHEN_SOLO and yak_PlayerIsSolo() then
      GreenLightFrame:Hide()
   else
      GreenLightFrame:Show()
   end
end

function GL_OnSetChannelClicked()
   GREENLIGHT_CONFIG.CHANNEL = GreenLightConfigFrameChannel:GetText()
   yak_print("GreenLight channel now set to "..GreenLightConfigFrameChannel:GetText())
   if GREENLIGHT_CONFIG.AUTO_JOIN_CHANNEL then
      GL_SetChannel({GreenLightConfigFrameChannel:GetText()})
      yak_print("You have joined this channel")
   else
      yak_print("You have not automatically joined this channel")
   end
   yak_print("You must manually leave the previous channel if you are no longer using it.")
end

function GL_ResizeButton(name, size)
   getglobal(name):SetWidth( size )
   getglobal(name):SetHeight( size )
--   getglobal(name.."IndicatorString"):SetFont("FRIZQT__.TTF",size/2,"OUTLINE","MONOCHROME" )
   getglobal(name.."IndicatorString"):SetTextHeight( size/2.5 )
end

function GL_ResizeIndicator( size )
   GL_ResizeButton("GreenLightFrameButton_red", size)
   GL_ResizeButton("GreenLightFrameButton_green", size)
   GL_ResizeButton("GreenLightFrameButton_yellow", size)
   GL_ResizeButton("GreenLightFrameUnknown",size)
   GreenLightFrame:SetHeight(size+10)
   GreenLightFrame:SetWidth(size*5+10)
end

function GL_SetIndicatorAlpha(alpha)
   GreenLightFrame:SetAlpha(alpha)
end

function GL_OnDragIndicatorSize()
   size = GreenLightConfigFrameIndicatorSizeSlider:GetValue()
   GREENLIGHT_CONFIG.INDICATOR_SIZE = size   
   getglobal(this:GetName().."Text"):SetText(GREENLIGHT_CONFIG_FRAME_INDICATOR_SIZE .. ":"..this:GetValue().."px");
   GL_ResizeIndicator(size)
end

GREENLIGHT_MODEL_EVENT_PLAYER_STATE_CHANGED = 1

function GREENLIGHT_MODEL:SetState( name, msg, reason, version, class )
   local changed = false
   if self.StateTable[name] == nil then
      self.StateTable[name] = {msg, reason, version, class}
   else
      if self.StateTable[name][1] ~= msg then
	 self.StateTable[name][1] = msg
	 changed = true
      end
      if  self.StateTable[name][2] ~= reason then
	 self.StateTable[name][2] = reason
	 changed = true
      end
      if self.StateTable[name][3] ~= version then
	 self.StateTable[name][3] = version
	 changed = true
      end
      if self.StateTable[name][4] ~= class then
	 self.StateTable[name][4] = class
	 changed = true
      end
   end
   if changed then
      self:NotifyObservers()
   end
end

function GREENLIGHT_MODEL:Version( name )
   return self.StateTable[name][3]
end

function GREENLIGHT_MODEL:Status()
   -- returns a table of the current characters' status
   -- keyed by color, with each item being the number of 
   -- players in that status
   self.StatusTable[GREENLIGHT_GREEN] = 0
   self.StatusTable[GREENLIGHT_RED] = 0
   self.StatusTable[GREENLIGHT_YELLOW] = 0
   self.StatusTable[GREENLIGHT_UNKNOWN] = 0
   for key,item in self.StateTable do
--      GL_Print(key .. ":" ..item[1] .. ":" .. item[2])
      self.StatusTable[item[1]] = self.StatusTable[item[1]] + 1
   end
   return self.StatusTable
end

function GREENLIGHT_MODEL:WorstStatus()
   local s = self:Status()
   local result
   if s[GREENLIGHT_RED] > 0 then
      result = GREENLIGHT_RED;
   elseif s[GREENLIGHT_YELLOW] > 0 then
      result = GREENLIGHT_YELLOW
   else
      result = GREENLIGHT_GREEN
   end
   GL_Log( result )
   return result
end

function GREENLIGHT_MODEL:SetMyStateAndReason( state, reason )
   self.MyState = state
   self.MyReason = reason
   local playerName = UnitName("player")
   if self.StateTable[playerName] == nil then
      self.StateTable[playerName] = { state, reason, GREENLIGHT_VERSION, GL_EnglishClass("player")} 
   else
      self.StateTable[playerName][1] = state
      self.StateTable[playerName][2] = reason
      self.StateTable[playerName][3] = GREENLIGHT_VERSION
      self.StateTable[playerName][4] = GL_EnglishClass("player")
   end
   self:NotifyObservers( GREENLIGHT_MODEL_EVENT_PLAYER_STATE_CHANGED )
end

function GREENLIGHT_MODEL:RefreshStateTable()
   -- create the new table using the 
   -- names of the characters in the current group
   local result
   if yak_PlayerIsSolo() then
      result = GL_BlankEntriesFromSolo()
   elseif yak_PlayerIsInGroup() then
      result = GL_BlankEntriesFromGroup()
   elseif yak_PlayerIsInRaid() then
      result = GL_BlankEntriesFromRaid()
   end
   for key,item in self.StateTable do
      if result[key] then
	 result[key] = item
      end
   end
   local mystate, myreason = GL_MyStateAndReason()
   result[UnitName("player")] = {mystate, myreason, GREENLIGHT_VERSION, GL_EnglishClass("player")}
   self.StateTable = result
   self:NotifyObservers()
end

function GREENLIGHT_OBSERVER:OnSubjectChange( subject, event )
   local new_state
   GL_Log("Calculating new state")
   new_state = GREENLIGHT_MODEL:WorstStatus()
   if new_state ~= GREENLIGHT_LAST_OVERALL_STATE then
      GL_Log("STATE CHANGE from " .. GREENLIGHT_LAST_OVERALL_STATE .. " to " .. new_state )
      -- set indicators
      GreenLightFrameButton_redIndicator:SetTexture("Interface\\Addons\\GreenLight\\Images\\red" .. GL_BrightOrDark(new_state, GREENLIGHT_RED))
      GreenLightFrameButton_yellowIndicator:SetTexture("Interface\\Addons\\GreenLight\\Images\\yellow" .. GL_BrightOrDark(new_state, GREENLIGHT_YELLOW))
      GreenLightFrameButton_greenIndicator:SetTexture("Interface\\Addons\\GreenLight\\Images\\green" .. GL_BrightOrDark(new_state, GREENLIGHT_GREEN))
      getglobal("GreenLightFrameButton_"..GREENLIGHT_LAST_OVERALL_STATE):SetNormalTexture("Interface\\Addons\\Greenlight\\Images\\buttonunpushed")
      getglobal("GreenLightFrameButton_"..new_state):SetNormalTexture("Interface\\Addons\\Greenlight\\Images\\buttonauto")
      -- play sound
      GREENLIGHT_LAST_OVERALL_STATE = new_state
   end
   -- update indicator strings
   GL_UpdateIndicatorStrings()

   if event == GREENLIGHT_MODEL_EVENT_PLAYER_STATE_CHANGED then
      -- set the button in the UI frame -- disable all first, then set ours
      GreenLightFrameButton_red:SetButtonState("NORMAL")
      GreenLightFrameButton_yellow:SetButtonState("NORMAL")
      GreenLightFrameButton_green:SetButtonState("NORMAL")
      getglobal("GreenLightFrameButton_"..GREENLIGHT_MY_STATE.MANUAL):SetButtonState("PUSHED", true)
   end
end

function GREENLIGHT_BROADCASTER:OnSubjectChange( subject, event )
   GL_Log("GREENLIGHT_BRODACASTER:OnSubjectChange")
   if event == GREENLIGHT_MODEL_EVENT_PLAYER_STATE_CHANGED then
      local color, reason = GL_MyStateAndReason()
      -- if not GL_HasJoinedChannel( GL_ChannelToUse() ) then
      --GL_SetChannel( {GL_ChannelToUse()} )
      -- end
      if color ~= self.LastBroadcastState then
	 self:BroadcastMyState()
      end
   end
end

function GREENLIGHT_BROADCASTER:BroadcastMyState()
   -- also broadcast this on the channel
   local color, reason = GL_MyStateAndReason()
   local channelName = GetChannelName(GL_ChannelToUse())
   if channelName == 0 then
      GL_Log("Channel "..GL_ChannelToUse().." is not joined; not broadcasting")
   else
      GL_Log("Broadcasting my state as " .. color .. " over channel " .. GetChannelName(GL_ChannelToUse()).. " (" .. GL_ChannelToUse() .. ")")
      SendChatMessage(GREENLIGHT_MESSAGE_PREFIX .. " " .. color.. " " .. reason .. " " .. GREENLIGHT_VERSION, "CHANNEL", "Common", GetChannelName(GL_ChannelToUse()) )
   end
   self.LastBroadcastState = color
end

